
import sys
import os
import os.path
import subprocess

def checkProg(name):
    """Check if name is installed on this machine"""
    proc = subprocess.Popen(['which', name], stdout=subprocess.PIPE)
    output = proc.stdout.read()
    if output == '' or output == '\n':
        print 'Error: %s not found, Install it first' % name
        return False
    return True
    
def main():
    if not checkProg('python'):
        print 'Install python on Ubuntu as follows'
        print 'sudo aptitude install python2.6-dev'
        return 1
    if not checkProg('swig'):
        print 'Install swig on Ubuntu as follows'
        print 'sudo aptitude install swig1.3'
        return 1

    try: 
        import dparser 
        dparser_loaded = True 
    except ImportError: 
        dparser_loaded = False 

    if not dparser_loaded:
        print 'Install dparser from http://dparser.sourceforge.net/'
        print 'tar -xzvf <.tgz file from above website>'
        print 'Follow instructions there. Also install python support for dparser from there'
        return 1

    print 'All components are correctly installed and available!'

    #
    # Check that we're in the right directory
    #
    proc = subprocess.Popen(['pwd'], stdout=subprocess.PIPE)
    output = proc.stdout.read()
    if output == '' or output == '\n':
        print 'Error: pwd failed!'
        return 1
    if output[-1] == '\n':
        pwd = output[0:-1]
    else:
        pwd = output
    srcpath = os.path.join(pwd, "src")
    srcpath = os.path.normpath(srcpath)
    if not os.path.isdir(srcpath):
        print 'Error: RUN THIS SCRIPT FROM THE ROOT DIRECTORY'
        print ' The root directory is the directory created by tar -xz'
        return 1

    #
    # create bin/ files
    #
    bindir = os.path.join(pwd, "bin")
    if not(os.path.isdir(bindir)):
        print 'Error: Directory %s does not exist; create it first' % bindir
        return 1

    #os.chdir(pwd + "/bin")
    exe = os.path.join(bindir, 'tempo2hsal')
    fp = open( exe, 'w')
    if 'SHELL' in os.environ.keys():
        shell = os.environ['SHELL']
    else:
        print 'ERROR: Environment variable SHELL not set!'
        return 1
    print >> fp, '#!', shell
    print >> fp, 'python ', os.path.join(srcpath, 'tempo2hsal.py'), ' $*'
    fp.close()

    subprocess.call(['chmod', '+x', exe])
    print 'Successfully created executable {0}'.format(exe)
    print 'Run make to test {0}'.format(exe)
    return 0

if __name__ == '__main__':
    main()

