
# ********************************************************************
# Functions for creating XML node for expressions
# ********************************************************************

def setDom(dom_arg):
  global dom
  dom = dom_arg

def createNodeTagChildn(tag, childNodes):
    global dom
    node = dom.createElement(tag)
    for i in childNodes:
        node.appendChild(i)
    return node

def createNodeTagChild(tag, childNode):
    return createNodeTagChildn(tag, [childNode])

def createNodeTagChild2(tag, childNode, childNode2):
    return createNodeTagChildn(tag, [childNode, childNode2])

def createNodeTagChild3(tag, childNode, childNode2, childNode3):
    return createNodeTagChildn(tag, [childNode, childNode2, childNode3])

def createNodeTagChild4(tag, childNode, childNode2, childNode3, childNode4):
    return createNodeTagChildn(tag, [childNode, childNode2, childNode3, childNode4])

def createNodeTag(tag, val):
    global dom
    valNode = dom.createTextNode(val)
    return createNodeTagChild(tag, valNode)

def createNodeApp(op, childs):
    tupleNode = createNodeTagChildn("TUPLELITERAL", childs)
    if isinstance(op, str):
        opNode = createNodeTag("NAMEEXPR", op)
    else:
        opNode = op
    appNode = createNodeTagChild2("APPLICATION", opNode, tupleNode)
    return appNode

def createNodeInfixApp(op, child1, child2):
    tupleNode = createNodeTagChild2("TUPLELITERAL", child1, child2)
    if isinstance(op, str):
        opNode = createNodeTag("NAMEEXPR", op)
    else:
        opNode = op
    appNode = createNodeTagChild2("APPLICATION", opNode, tupleNode)
    appNode.setAttribute('INFIX', 'YES')
    return appNode

def createNodeInfixAppRec(op, nodeList):
    n = len(nodeList)
    if n == 0:
        return None
    node = nodeList[0]
    for i in range(n-1):
        node = createNodeInfixApp(op, node, nodeList[i+1])
    return node

def createNodeAnd(nodeList):
    ans = createNodeInfixAppRec('AND', nodeList)
    if ans == None:
        return createNodeTag("NAMEEXPR", "TRUE")
    return ans

def createNodePlus(nodeList):
    ans = createNodeInfixAppRec('+', nodeList)
    #if ans == None:
        #return createNodeTag("NUMERAL", "0")
    return ans
# ********************************************************************
